#include <cstdio>
#include <cassert>
#include <algorithm>

using namespace std;

const int MAXN = 200100;

int p[MAXN];
int c[MAXN];
int size[MAXN];
int tot_size;

int get(int v) {
  if (p[v] != v) return v = get(p[v]);
  return p[v];
}

void join(int a, int b) {
  a = get(a);
  b = get(b);

  if (a == b) {
    assert(!c[a]);
    c[a] = true;
    tot_size += size[a];
    return;
  }

  if (c[a] && !c[b]) tot_size += size[b];
  if (!c[a] && c[b]) tot_size += size[a];

  if (size[a] > size[b]) swap(a, b);

  p[a] = b;
  c[b] |= c[a];
  size[b] += size[a];
}
  

int main() {
  int n, m, q;
  scanf("%d%d%d", &n, &m, &q);

  for (int i = 0; i < n; i++) p[i] = i, size[i] = 1;
  for (int i = 0; i < m; i++) {
    int a, b;
    scanf("%d%d", &a, &b);
    --a, --b;
    join(a, b);
  }

  for (int i = 0; i < q; i++) {
    int ty;
    scanf("%d", &ty);
    if (ty == 1 || ty == 2) {
      int a, b;
      scanf("%d%d", &a, &b);
      --a, --b;
      if (c[get(a)] + c[get(b)] > 1) {
        printf("No\n");
      } else {
        printf("Yes\n");
        if (ty == 2) {
          join(a, b);
        }
      }
    } else {
      printf("%lld\n", 2 * tot_size * 1LL * (n - tot_size) + (n - tot_size) * 1LL * (n - tot_size - 1));
    }
  }
}
