#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <cstdlib>
#include <vector>
#include <set>
#include <map>
#include <cassert>
#include <queue>
#include <ctime>
#include <string>
#include <cstring>
#define mp make_pair
#define pb push_back
#define NAME ""
#define y1 y1_423
#define list lista

using namespace std;

typedef long long ll;
typedef long double ld;

template<typename T>
ostream& operator << (ostream& cout, const vector<T> &a) {
	if ((int)a.size() == 0) {
		return (cout << "()");
	}
	cout << "(" << a[0];
	for (int i = 1; i < (int)a.size(); i++) {
		cout << "; " << a[i];
	}
	return (cout << ")");
}

template<typename T>
ostream& operator << (ostream& cout, const set<T> &a) {
	if ((int)a.size() == 0) {
		return (cout << "{}");
	}
	auto it = a.begin();
	cout << "{" << *it;
	++it;
	for (; it != a.end(); ++it) {
		cout << "; " << *it;
	}
	return (cout << "}");
}

template<typename T>
ostream& operator << (ostream& cout, const multiset<T> &a) {
	if ((int)a.size() == 0) {
		return (cout << "{}");
	}
	auto it = a.begin();
	cout << "{" << *it;
	++it;
	for (; it != a.end(); ++it) {
		cout << "; " << *it;
	}
	return (cout << "}");
}

template<typename T1, typename T2>
ostream& operator << (ostream& cout, const pair<T1, T2> &a) {
	return cout << "(" << a.first << "; " << a.second << ")";
}

const int nmax = 2000 * 1000;
const int inf = 2000 * 1000 * 1000;
const ll infl = 1000ll * 1000ll * 1000ll * 1000ll * 1000ll * 1000ll;
const int mod = 1000 * 1000 * 1000 + 7;
const ld pi = acos(-1.0);

int n, m, q, x, y;
pair<int, int> a[nmax], b[nmax];
vector<int> go[nmax];
int color[nmax], qq[nmax], cnt[nmax];
bool used[nmax];

bool CanPut(int x, int y) {
	for (int i = 0; i < n; i++) {
		b[i] = a[i];
	}
	pair<int, int> now = mp(x, y);
	for (int i = 0; i < 2 * n; i++) {
		if (b[now.first].first == 0 && b[now.first].second == 0) {
			b[now.first] = now;
			return true;
		} else {
			pair<int, int> nn = b[now.first];
			b[now.first] = now;
			now = mp(nn.first ^ nn.second ^ now.first, now.first);
		}
	}
	return false;
}

void dfs(int v, int col) {
	color[v] = col;
	qq[col]++;
	used[v] = true;
	for (int u : go[v]) {
		if (!used[u]) {
			dfs(u, col);
		}
	}
}

int Ask() {
	for (int i = 0; i < n; i++) {
		used[i] = false;
		cnt[i] = 0;
		qq[i] = 0;
	}
	int top = 1, cir = 0, ncir = 0;
	for (int i = 0; i < n; i++) {
		if (!used[i]) {
			dfs(i, top++);
		}
	}
	for (int i = 0; i < n; i++) {
		cnt[color[i]] += go[i].size();
	}
	for (int i = 0; i < top; i++) {
		if (cnt[i] / 2 == qq[i]) {
			cir += qq[i];
		} else {
			ncir += qq[i];
		}
	}
	return 2 * cir * ncir + ncir * (ncir - 1);
}

bool TryPut(int x, int y) {
	pair<int, int> now = mp(x, y);
	for (int i = 0; i < 3990; i++) {
		if (a[now.first].first == 0 && a[now.first].second == 0) {
			a[now.first] = now;
			return true;
		} else {
			pair<int, int> nn = a[now.first];
			a[now.first] = now;
			now = mp(nn.first ^ nn.second ^ now.first, now.first);
		}
	}
	return false;
}

int main() {
	scanf("%d%d%d", &n, &m, &q);
	for (int i = 0; i < m; i++) {
		scanf("%d%d", &x, &y);
		x--, y--;
		a[x] = mp(x, y);
		go[x].pb(y);
		go[y].pb(x);
	}
	for (int i = 0; i < q; i++) {
		int t;
		scanf("%d", &t);
		if (t == 1) {
			scanf("%d%d", &x, &y);
			x--, y--;
			if (CanPut(x, y)) {
				printf("Yes\n");
			} else {
				printf("No\n");
			}
		} else if (t == 2) {
			scanf("%d%d", &x, &y);
			x--, y--;
			if (TryPut(x, y)) {
				go[x].pb(y);
				go[y].pb(x);
				printf("Yes\n");
			} else {
				printf("No\n");
			}
		} else if (t == 3) {
			printf("%d\n", Ask());
		}
	}
	return 0;
}

