#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <cstdlib>
#include <vector>
#include <set>
#include <map>
#include <cassert>
#include <queue>
#include <ctime>
#include <string>
#include <cstring>
#define mp make_pair
#define pb push_back
#define NAME ""
#define y1 y1_423
#define list lista

using namespace std;

typedef long long ll;
typedef long double ld;

template<typename T>
ostream& operator << (ostream& cout, const vector<T> &a) {
	if ((int)a.size() == 0) {
		return (cout << "()");
	}
	cout << "(" << a[0];
	for (int i = 1; i < (int)a.size(); i++) {
		cout << "; " << a[i];
	}
	return (cout << ")");
}

template<typename T>
ostream& operator << (ostream& cout, const set<T> &a) {
	if ((int)a.size() == 0) {
		return (cout << "{}");
	}
	auto it = a.begin();
	cout << "{" << *it;
	++it;
	for (; it != a.end(); ++it) {
		cout << "; " << *it;
	}
	return (cout << "}");
}

template<typename T>
ostream& operator << (ostream& cout, const multiset<T> &a) {
	if ((int)a.size() == 0) {
		return (cout << "{}");
	}
	auto it = a.begin();
	cout << "{" << *it;
	++it;
	for (; it != a.end(); ++it) {
		cout << "; " << *it;
	}
	return (cout << "}");
}

template<typename T1, typename T2>
ostream& operator << (ostream& cout, const pair<T1, T2> &a) {
	return cout << "(" << a.first << "; " << a.second << ")";
}

const int nmax = 2000 * 1000;
const int inf = 2000 * 1000 * 1000;
const ll infl = 1000ll * 1000ll * 1000ll * 1000ll * 1000ll * 1000ll;
const int mod = 1000 * 1000 * 1000 + 7;
const ld pi = acos(-1.0);

ll cnt1, cnt;

struct node {
	int rg, p, sz, cnt;
	node(int Rg = 0, int P = -1, int X = 0, int Y = 0) {
		rg = Rg;
		sz = X;
		cnt = Y;
		p = P;
	}
};

node dsu[nmax];

int getpar(int x) {
	int y = x;
	while (dsu[x].p != x) {
		x = dsu[x].p;
	}
	while (y != x) {
		int np = dsu[y].p;
		dsu[y].p = x;
		y = np;
	}
	return y;
}

void join(int x, int y) {
	x = getpar(x);
	y = getpar(y);
	if (x == y) {
		dsu[x].cnt++;
		cnt1 -= dsu[x].sz;
		cnt += dsu[x].sz;
		return;
	}
	if (dsu[x].rg == dsu[y].rg) {
		dsu[x].rg++;
	}

	if (dsu[y].cnt == dsu[y].sz - 1) {
		cnt1 -= dsu[y].sz;
	} else {
		cnt -= dsu[y].sz;
	}
	if (dsu[x].cnt == dsu[x].sz - 1) {
		cnt1 -= dsu[x].sz;
	} else {
		cnt -= dsu[x].sz;
	}

	if (dsu[x].rg > dsu[y].rg) {
		dsu[y].p = x;
		dsu[x].sz += dsu[y].sz;
		dsu[x].cnt += dsu[y].cnt;
	} else {
		dsu[x].p = y;
		dsu[y].sz += dsu[x].sz;
		dsu[y].cnt += dsu[x].cnt;
	}

	x = getpar(x);
	dsu[x].cnt++;
	if (dsu[x].cnt == dsu[x].sz - 1) {
		cnt1 += dsu[x].sz;
	} else {
		cnt += dsu[x].sz;
	}

}

bool CanPut(int x, int y) {
	x = getpar(x);
	y = getpar(y);
	if (x == y) {
		if (dsu[x].sz < dsu[x].cnt + 1) {
			return false;
		} else {
			return true;
		}
	} else {
		if (dsu[x].sz + dsu[y].sz < dsu[x].cnt + dsu[y].cnt + 1) {
			return false;
		} else {
			return true;
		}
	}
}

bool TryPut(int x, int y) {
	x = getpar(x);
	y = getpar(y);
	if (x == y) {
		if (dsu[x].sz < dsu[x].cnt + 1) {
			return false;
		} else {
			join(x, y);
			return true;
		}
	} else {
		if (dsu[x].sz + dsu[y].sz < dsu[x].cnt + dsu[y].cnt + 1) {
			return false;
		} else {
			join(x, y);
			return true;
		}
	}
}

int n, m, q, x, y, t;

int main() {
	//freopen("input.txt", "r", stdin);freopen("output.txt", "w", stdout);
	//freopen(NAME".in", "r", stdin);freopen(NAME".out", "w", stdout);
	scanf("%d%d%d", &n, &m, &q);
	cnt1 = n;
	cnt = 0;
	for (int i = 0; i < n; i++) {
		dsu[i].sz = 1;
		dsu[i].cnt = 0;
		dsu[i].p = i;
	}
	for (int i = 0; i < m; i++) {
		scanf("%d%d", &x, &y);
		x--, y--;
		join(x, y);
	}
	for (int i = 0; i < q; i++) {
		scanf("%d", &t);
		if (t == 1) {
			scanf("%d%d", &x, &y);
			x--, y--;
			if (CanPut(x, y)) {
				printf("Yes\n");
			} else {
				printf("No\n");
			}
		} else if (t == 2) {
			scanf("%d%d", &x, &y);
			x--, y--;
			if (TryPut(x, y)) {
				printf("Yes\n");
			} else {
				printf("No\n");
			}
		} else if (t == 3) {
			printf("%lld\n", cnt1 * (cnt1 - 1) + 2 * cnt1 * cnt);
		}
	}
	return 0;
}
